#!/usr/bin/perl

# Unmounting daemon, author Z. Wagner, http://icebearsoft.euweb.cz
use strict;
our $FileId = '$Id: zwumountd.pl 838 2010-12-27 16:34:42Z zw $';

# Important variables
our $sleeptime = 10;
our (@allowdev, @allowmtpoint, @allowtype);

if (-f '/etc/zwumountd.conf') {
  do '/etc/zwumountd.conf';
}

my $pidfile = '/var/run/zwumountd.pl.pid';
my $mount = '/bin/mount';
my $umount = '/bin/umount';

open(PID, ">$pidfile") or die "Cannot write to the PID file.\n";
print PID "$$\n";
close PID;

$::SIG{TERM} = sub {
  $::SIG{TERM} = 'DEFAULT';
  unlink $pidfile;
  exit 0;
};

print "$FileId\n";

# Read and parse /etc/fstab
my %fstab;
open(FSTAB, '/etc/fstab') && do {
  while (<FSTAB>) {
    chomp;
    my @fstab = split /\s+/, $_;
    $fstab{$fstab[1]} = $fstab[0];
  }
  close FSTAB;
};

# Endless loop
while (1) {
  sleep $sleeptime;
  MOUNT: foreach (`$mount`) {
    chomp;
    if (/^(\S+)\s+on\s+(\S+)\s+type\s+(\S+)/) {
      my $dev = $1;
      my $mntpt = $2;
      my $fstype = $3;
      if ($dev !~ /^\//) {
          next MOUNT;
      }
      if (exists $fstab{$mntpt}) {
        next MOUNT;
      }
      foreach (@allowdev) {
        if ($dev =~ /$_/) {
          next MOUNT;
        }
      }
      foreach (@allowmtpoint) {
        if ($mntpt =~ /$_/) {
          next MOUNT;
        }
      }
      foreach (@allowtype) {
        if ($fstype =~ /$_/) {
          next MOUNT;
        }
      }
      system "$umount $mntpt 2>/dev/null";
    }
  }
}
